#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

/* Non standard include */
#include <commtech.h>
#include <specific_comm.h>


void *create_comm_channel(void)
{
	struct channel *channel;

	if (!posix_memalign((void *) &channel, CACHE_LINE_SIZE, sizeof(struct channel)))
	{
		if (!posix_memalign((void *) &channel->shared_space, CACHE_LINE_SIZE, SHARED_SPACE_SIZE))
		{
			channel->cons_idx = 0;
			channel->prod_idx = 0;
			return channel;
		}
		else
			free(channel);
	}
	return NULL;
}

int end_producer(void *unused __attribute__ ((unused)))
{
	return 0;
}

int destroy_comm_channel(void *channel)
{
	free((void *) ((struct channel *) channel)->shared_space);
	free(channel);
	return 0;
}

void *recv_one_data(struct channel *channel)
{
	unsigned int cons_idx;
	void *result;

	cons_idx = channel->cons_idx;
	while (cons_idx == channel->prod_idx);
	result = channel->shared_space[cons_idx];
	cons_idx = (cons_idx + 1) % SHARED_SPACE_VOIDPTR;
	channel->cons_idx = cons_idx;
	return result;
}

ssize_t recv_some_data(struct channel *channel, void **buf, size_t count)
{
	unsigned int n, cons_idx;

	n = 0;
	for(cons_idx = channel->cons_idx; cons_idx != channel->prod_idx; cons_idx = (cons_idx + 1) % SHARED_SPACE_VOIDPTR, channel->cons_idx = cons_idx)
	{
		/*
		 * The behaviour of this is not documented but we know
		 * the values inside buf won't change during this affectation
		 */
		*buf++ = channel->shared_space[cons_idx];
		if (++n == count)
			break;
	}
	return n;
}
